-- Sokrates Client Script
-- Zweck: Reparatur der "falschen Einschreiber" nach der Migration der Stadt Salzburg
-- Erstellung der Einspiel-Scripts fr Sokrates WEB
-- Umsetzung erfolgt einzeln pro Schule mit der jeweiligen Schul-DB der Migration
-- 2009-12-06: (gr) Erstellung 
-- 2009-12-07: (gr) Erweiterung
-- 2009-12-08: (gr) Optimierung nach Abstimmung mit BB
-- 2009-12-08: (gr) Fertigstellung fr universellen Einsatz

-- 2009-12-08: (gr) umgesetzt fr die VS Gnigl (501021)
-- 2009-12-08: (gr) umgesetzt fr die VS Leopoldskron (501071)

set server server1;
install database sokvolv;
connect sokvolv avv gammax;

-- SG_ID in der SG ergnzen - hier merken wir uns die falsche SG_Kennzahl aus Sokrates WEB

alter table avv.sg add SG_ID DECIMAL(12,0);

commit;

-- SWITCH to Sokrates WEB
-- UPDATE-Statements aus Sokrates WEB bernehmen und ablaufen lassen
-- Muster: UPDATE SG SET SG_ID = 1060211 WHERE SG_FAMNAME = 'Zippusch' AND SG_Vorname1 LIKE 'Raphael%' AND SG_GEBURTDAT = 1999-06-19

-- VSTaxham

UPDATE SG SET SG_ID = 1100115 WHERE SG_FAMNAME LIKE 'Ahmad%' AND SG_Vorname1 LIKE 'Iman%' AND SG_GEBURTDAT = 2003-01-16;
UPDATE SG SET SG_ID = 1100125 WHERE SG_FAMNAME LIKE 'Akmanlar%' AND SG_Vorname1 LIKE 'Niklas%' AND SG_GEBURTDAT = 2003-01-29;
UPDATE SG SET SG_ID = 1100148 WHERE SG_FAMNAME LIKE 'Aniagyei%' AND SG_Vorname1 LIKE 'Jophiel%' AND SG_GEBURTDAT = 2002-12-28;
UPDATE SG SET SG_ID = 1100198 WHERE SG_FAMNAME LIKE 'Benischko%' AND SG_Vorname1 LIKE 'Aylin%' AND SG_GEBURTDAT = 2003-07-19;
UPDATE SG SET SG_ID = 1100199 WHERE SG_FAMNAME LIKE 'Benkovic%' AND SG_Vorname1 LIKE 'David%' AND SG_GEBURTDAT = 2003-03-12;
UPDATE SG SET SG_ID = 1100225 WHERE SG_FAMNAME LIKE 'Bogdanovichus%' AND SG_Vorname1 LIKE 'Georg%' AND SG_GEBURTDAT = 2002-10-07;

commit;

stopp;

-- Gltige Kennzahlen ermitteln
-- danach im gltigen Kennzahlen der jeweiligen Schule (Kopiervorlage)
-- (501071090001,501071090002,501071090003,501071090004,501071090005,501071090006,501071090007,501071090008,501071090009,501071090010,501071090011,501071090012,501071090013,501071090014,501071090015,501071090016,501071090017,501071090018,501071090019,501071090020,501071090021,501071090022,501071090023,501071090024,501071090025,501071090026,501071090027,501071090028,501071090029,501071090030,501071090031,501071090033,501071090034,501071090035,501071090036,501071090037,501071090038,501071090039,501071090040,501071090041,501071090042,501071090043,501071090045,501071090046,501071090047,501071090048,501071090049,501071090050,501071090051,501071090052,501071090053,501071090054,501071090055,501071090056,501071090057,501071090058,501071090059,501071090060,501071090061,501071090062,501071090063,501071090064,501071090065,501071090066)

select DISTINCT SG_Kennzahl || ',' from avv.sg
where sg_id is not null
order by 1;

-- Falsche Kennzahlen ermitteln

select DISTINCT SG_ID || ',' from avv.sg
where sg_id is not null
order by 1;

-- SVNR dieser SchlerInnen ermitteln
-- Diese werden auf Vorhandensein im DUMP geprft.

select '''' || SG_SVNR || ''',' from avv.sg
where sg_id is not null
order by 1;

commit;

-- Alle aktiven SchlerInnen im SJ 2009/10 ermitteln

select SG.SG_KENNZAHL || ';' || SG_ID || ';' || SG_FAMNAME || ';' || SG_VORNAME1 || ';' || @DATETOCHAR(SG_Geburtdat,'dd.MM.yyyy') || ';' || SG_SVNR
from sg, sk
where sg.sg_kennzahl = sk.sg_kennzahl 
and sk.sj_schuljahr = 2010
order by SG_Famname, SG_Vorname1, SG_Geburtdat;

-- SG-INSERT-Statement fr die "falschen" Einschreiber

select 'INSERT INTO SCHUELER (SG_KENNZAHL,SG_FAMNAME,SG_VORNAME1,SG_VORNAME2,SG_SEX,SG_GEBURTDAT,SG_GEBURTORT,SG_GEBURTSTAAT,
SG_STAATSBUERGERSCHAFT,SG_RELIGION,SG_SPRACHE,SG_SVNR,SG_AKTIVKZ,SG_UPDATEDAT,VERSION) 
VALUES (' || SG_Kennzahl, 
 ', ''' || SG_Famname || ''', '''  || SG_Vorname1 || ''', ''' || SG_Vorname2 || ''', ''' || @LOWER(SG_Sex) || ''', ', 
 'TO_DATE(''' || @DATETOCHAR(SG_Geburtdat,'dd.MM.yyyy') || ''',''dd.mm.yyyy''), ''' || SG_GEBURTORT || ''', ''' || AL_Kuerzel
 || ''', ''' || SG_STAAT || ''', ''' || SG_RELIGION  || ''', ''' || SG_SPRACHE || ''', ''' || SG_SVNR
 || ''', 1, ' 
 || '''08.12.2009'''
 || ', 1);' 
from sg, al
where sg_id is not null
and sg_land = AL_Bezeichnung 
and al_art = 9
order by SG.SG_Kennzahl;

-- SA-INSERT-Statement fr die "falschen" Einschreiber

select 'INSERT INTO SCHUELERADRESSE (SG_KENNZAHL,SA_ID,GM_ID,SA_ART,SA_ANREDE,SA_AKADGRAD,SA_FAMNAME,SA_VORNAME,
SA_LANDKZ,SA_PLZ,SA_ORT,SA_STRASSE, ',  
'SA_TEL1,SA_TEL2,SA_FAX,SA_BERUF,SA_WOHNTHIERKZ,SA_ERZBERECHTKZ,SA_ANMERKUNG,
SA_ZAHLPFLICHTKZ,SA_BILDUNGSORT,SA_HEIMATADRESSE,SA_POSTAN,SA_HWS,SA_ANREDE1,SA_ANREDE2,SA_UPDATEDAT,VERSION) 
VALUES (' || SG.SG_Kennzahl || ', SA_ID_SEQUENCE.NEXTVAL, 0, ', 
 '''' || SA_ART || ''', ''' || SA_Anrede || ''', ''' || SA_Titel || ''', ''' || SA_Famname || ''', ''' || SA_Vorname 
 || ''', ''' || SA_LandKz || ''', ''' || SA_Plz || ''', ''' || SA_Ort || ''', ''' || SA_Strasse
 || ''', ''' || SA_Tel1 || ''', ''' || SA_Tel2 || ''', ''' || SA_Fax || ''', ''' || @LEFT(@TRIM(SA_Beruf),30) || ''', '
 || @EXACT(SA_WohntBei,'J') || ', ' ,
 @EXACT(SA_Vormund,'J') || ', ''' || SA_Beruf || ' Memo: ' || SA_Memo || ''', ' 
 || @EXACT(SA_WohntBei,'J') || ', 0, ' || @EXACT(SA_WohntBei,'J') || ', ' || @EXACT(SA_WohntBei,'J') || ', ' || @EXACT(SA_WohntBei,'J')
 || ', ''' || SA_Anrede || ''', ''' || SA_Vorname || ' ' || SA_Famname || ''', ' 
 || '''08.12.2009'''
 || ', 1);' 
from sa, sg
where sg_id is not null
and sg.sg_kennzahl = sa.sg_kennzahl
order by SG.SG_Kennzahl;

-- SCHUELERLAUFBAHN umkopieren

select 'INSERT INTO SCHUELERLAUFBAHN 
 (SU_KENNZAHL,SJ_SCHULJAHR,KL_ID,SG_KENNZAHL,SK_ID,GM_ID,MF_ID,STT_ID,SK_VON,SK_BIS,SK_SCHULSTUFE,SK_BESUCHSJAHR,', 
 'SK_KKZ,SK_WOCHEN,SK_ART,SK_SPRENGELFREMDKZ,SK_SCHULFORM,SK_ANMERKUNG,SK_UPDATEDAT,VERSION,SK_DATUMBIDOK) 
 SELECT SU_KENNZAHL,SJ_SCHULJAHR,KL_ID, ', 
 SG_Kennzahl || ',SK_ID,GM_ID,MF_ID,STT_ID,SK_VON,SK_BIS,SK_SCHULSTUFE,SK_BESUCHSJAHR,', 
 'SK_KKZ,SK_WOCHEN,SK_ART,SK_SPRENGELFREMDKZ,SK_SCHULFORM,SK_ANMERKUNG,SK_UPDATEDAT,VERSION,SK_DATUMBIDOK
 FROM SCHUELERLAUFBAHN WHERE SG_KENNZAHL = ' || SG_ID || ';'
from sg
where sg_id is not null
order by SG.SG_Kennzahl;

-- Ausbildung umkopieren

select 'INSERT INTO AUSBILDUNG 
 (AUSB_KZ,SU_KENNZAHL,SG_KENNZAHL,AUSB_STAG,AUSB_INDEX,AUSB_STAND,AUSB_BEGINNDATUM,AUSB_ENDEDATUM,AUSB_UPDATEDAT,VERSION) 
 SELECT AUSB_ID_SEQUENCE.NEXTVAL,SU_KENNZAHL, ' , 
 SG_Kennzahl || ',AUSB_STAG,AUSB_INDEX,AUSB_STAND,AUSB_BEGINNDATUM,AUSB_ENDEDATUM,AUSB_UPDATEDAT,VERSION
 FROM AUSBILDUNG WHERE SG_KENNZAHL = ' || SG_ID || ';'
from sg
where sg_id is not null
order by SG.SG_Kennzahl;

-- DEL_SCHUELERLAUFBAHN umkopieren

select 'INSERT INTO DEL_SCHUELERLAUFBAHN
 (DEL_USER,DEL_DATUM,SU_KENNZAHL,SJ_SCHULJAHR,KL_ID,SG_KENNZAHL,SK_ID,GM_ID,MF_ID,STT_ID,SK_VON,SK_BIS,SK_SCHULSTUFE,SK_BESUCHSJAHR, ', 
 'SK_KKZ,SK_WOCHEN,SK_ART,SK_SPRENGELFREMDKZ,SK_SCHULFORM,SK_ANMERKUNG,SK_UPDATEDAT,VERSION)
 SELECT DEL_USER,DEL_DATUM,SU_KENNZAHL,SJ_SCHULJAHR,KL_ID,' , 
 SG_Kennzahl || ',SK_ID,GM_ID,MF_ID,STT_ID,SK_VON,SK_BIS,SK_SCHULSTUFE,SK_BESUCHSJAHR,SK_KKZ,SK_WOCHEN,SK_ART,SK_SPRENGELFREMDKZ,SK_SCHULFORM,SK_ANMERKUNG,SK_UPDATEDAT,VERSION
 FROM DEL_SCHUELERLAUFBAHN WHERE SG_KENNZAHL = ' || SG_ID || ';'
from sg
where sg_id is not null
order by SG.SG_Kennzahl;

-- DELSG umkopieren

select 'INSERT INTO DELSG
 (SG_KENNZAHL)
 SELECT ' || SG_Kennzahl || '
 FROM DELSG WHERE SG_KENNZAHL = ' || SG_ID || ';'
from sg
where sg_id is not null
order by SG.SG_Kennzahl;

-- ERGAENZUNGSATTRIBUTE umkopieren

select 'INSERT INTO ERGAENZUNGSATTRIBUTE
 (SG_KENNZAHL,EA_NUMMER1,EA_NUMMER2,EA_NUMMER3,EA_NUMMER4,EA_NUMMER5,EA_STRING1,EA_STRING2,EA_STRING3,EA_STRING4,EA_STRING5, ' , 
 'EA_CHECKBOX1,EA_CHECKBOX2,EA_CHECKBOX3,EA_CHECKBOX4,EA_CHECKBOX5,EA_DATUM1,EA_DATUM2,EA_DATUM3,EA_DATUM4,EA_DATUM5,EA_UPDATEDAT,VERSION)
 SELECT ' , 
 SG_Kennzahl || ',EA_NUMMER1,EA_NUMMER2,EA_NUMMER3,EA_NUMMER4,EA_NUMMER5,EA_STRING1,EA_STRING2,EA_STRING3,EA_STRING4,EA_STRING5, ' , 
 'EA_CHECKBOX1,EA_CHECKBOX2,EA_CHECKBOX3,EA_CHECKBOX4,EA_CHECKBOX5,EA_DATUM1,EA_DATUM2,EA_DATUM3,EA_DATUM4,EA_DATUM5,EA_UPDATEDAT,VERSION 
 FROM ERGAENZUNGSATTRIBUTE WHERE SG_KENNZAHL = ' || SG_ID || ';'
from sg
where sg_id is not null
order by SG.SG_Kennzahl;

-- LEHRPLANFESTLEGUNG umkopieren

select 'INSERT INTO LEHRPLANFESTLEGUNG
 (LP_ID,SU_KENNZAHL,SJ_SCHULJAHR,SG_KENNZAHL,LP_VON,LP_BIS,GA_ID,FA_ID,LP_SCHULSTUFE,LP_SCHULART,LP_UPDATEDAT,VERSION)
 SELECT LP_ID_SEQUENCE.NEXTVAL,SU_KENNZAHL,SJ_SCHULJAHR, ' , 
 SG_Kennzahl || ',LP_VON,LP_BIS,GA_ID,FA_ID,LP_SCHULSTUFE,LP_SCHULART,LP_UPDATEDAT,VERSION 
 FROM LEHRPLANFESTLEGUNG WHERE SG_KENNZAHL = ' || SG_ID || ';'
from sg
where sg_id is not null
order by SG.SG_Kennzahl;

-- MERKMALSZUORDNUNG umkopieren

select 'INSERT INTO MERKMALSZUORDNUNG
 (SG_KENNZAHL,MZ_INDEX,MK_NAME_2,MM_NAMEKURZ_2,MM_NAMELANG_2,SU_KENNZAHL,SJ_SCHULJAHR,MZ_TEXT,MZ_VON,MZ_BIS,MZ_WERT, ', 
 'MZ_UPDATEDAT,VERSION,MZ_MEMO,MZ_STAMMDATEN,MZ_DATEI,GN_ID,MZ_GENEHMIGER,MZ_GENDAT)
 SELECT ', 
 SG_Kennzahl || ',MZ_ID_SEQUENCE.NEXTVAL,MK_NAME_2,MM_NAMEKURZ_2,MM_NAMELANG_2,SU_KENNZAHL,SJ_SCHULJAHR,MZ_TEXT,MZ_VON,MZ_BIS,MZ_WERT, ', 
 'MZ_UPDATEDAT,VERSION,MZ_MEMO,MZ_STAMMDATEN,MZ_DATEI,GN_ID,MZ_GENEHMIGER,MZ_GENDAT
 FROM MERKMALSZUORDNUNG WHERE SG_KENNZAHL = ' || SG_ID || ';'
from sg
where sg_id is not null
order by SG.SG_Kennzahl;

-- SCHUELERGRUPPE umkopieren

select 'INSERT INTO SCHUELERGRUPPE
 (SGG_ID,SU_KENNZAHL,SJ_SCHULJAHR,UG_ID,SG_KENNZAHL,SGG_AKT_LG,SGG_VON,SGG_BIS,SGG_UPDATEDAT,VERSION)
 SELECT SGG_ID_SEQUENCE.NEXTVAL,SU_KENNZAHL,SJ_SCHULJAHR,UG_ID,',  
 SG_Kennzahl || ',SGG_AKT_LG,SGG_VON,SGG_BIS,SGG_UPDATEDAT,VERSION
 FROM SCHUELERGRUPPE WHERE SG_KENNZAHL = ' || SG_ID || ';'
from sg
where sg_id is not null
order by SG.SG_Kennzahl;


-- ZEUGNIS umkopieren

select 'INSERT INTO ZEUGNIS
 (SU_KENNZAHL,SJ_SCHULJAHR,KL_ID,SG_KENNZAHL,SK_ID,ZG_ID,ZG_ART,ZG_DATUM,ZG_ORT,ZG_LEHRER,ZG_LEITER,', 
 'ZG_ANMERKUNG,ZG_DRUCKVORL,ZG_JAHRESERFOLG,ZG_EDITKZ,ZG_NOPRINTKZ,ZG_UPDATEDAT,VERSION,ZG_SCHWERPUNKT,ZG_STT_ID,ZG_DL_USER,
 ZG_DL_DATE,ZG_LEHRER2,ZG_LEHRBERUF,ZG_FACHBEREICH,ZG_SCHULART,ZG_LEHRER2FUNKTION,ZG_RELIGION)
 SELECT ', 
 'SU_KENNZAHL,SJ_SCHULJAHR,KL_ID, ',  
 SG_Kennzahl || ',SK_ID,ZG_ID,ZG_ART,ZG_DATUM,ZG_ORT,ZG_LEHRER,ZG_LEITER,ZG_ANMERKUNG,
 ZG_DRUCKVORL,ZG_JAHRESERFOLG,ZG_EDITKZ,ZG_NOPRINTKZ,ZG_UPDATEDAT,VERSION,ZG_SCHWERPUNKT,ZG_STT_ID,ZG_DL_USER,', 
 'ZG_DL_DATE,ZG_LEHRER2,ZG_LEHRBERUF,ZG_FACHBEREICH,ZG_SCHULART,ZG_LEHRER2FUNKTION,ZG_RELIGION
 FROM ZEUGNIS WHERE SG_KENNZAHL = ' || SG_ID || ';'
from sg
where sg_id is not null
order by SG.SG_Kennzahl;

-- NOTE umkopieren mittels UPDATE

select 'UPDATE NOTE SET SG_Kennzahl = ' || SG_Kennzahl || ' WHERE SG_KENNZAHL = ' || SG_ID || ';'
from sg
where sg_id is not null
order by SG.SG_Kennzahl;

-- NOTE_ARCHIV umkopieren mittels UPDATE

select 'UPDATE NOTE_ARCHIV SET SG_Kennzahl = ' || SG_Kennzahl || ' WHERE SG_KENNZAHL = ' || SG_ID || ';'
from sg
where sg_id is not null
order by SG.SG_Kennzahl;

-- ZEUGNISKLAUSEL umkopieren mittels UPDATE

select 'UPDATE ZEUGNISKLAUSEL SET SG_Kennzahl = ' || SG_Kennzahl || ' WHERE SG_KENNZAHL = ' || SG_ID || ';'
from sg
where sg_id is not null
order by SG.SG_Kennzahl;

commit;

